using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace LabClient_cs
{
    enum ZakajKonec { Napaka = 0, Zmaga = 1, Drugo = 2 };
    enum Premik
    {
        Naprej = 1,
        Levo = 2,
        Desno = 3,
        Obrni = 4, // obrat za 180 stopinj
        Poberi = 5,
        Spusti = 6
    };

    enum TipPolja
    {
        Prosto = 1,
        Izhod = 2,
        KockaAliZid = 3,
        ZunanjiZid = 4
    };

    struct VidenoPolje
    {
        internal int rowsAhead; // koliko vrstic pred nasim robotom je to polje: 1..vidljivost
        internal int column; // koliko stolpcev levo ali desno od nasega robota je to polje: -rowsAhead <= column <= rowsAhead
        internal TipPolja tip;
    };

    class Robot
    {
        public static String Ime = "C#Robot"; // Tu vpisi ime svojega robota.

        Random rnd;

        public Robot()
        {
            rnd = new Random();
        }

        public void ZbudiSe(int sirina, int visina, int vidljivost)
        {
            // Tu dodaj svojo implementacijo.
            Console.WriteLine(string.Format("Igram na mrezi {0} * {1}, vidljivost = {2}.", sirina, visina, vidljivost));
        }

        public Premik KamGres(bool nosimBreme, VidenoPolje[] kajVidim)
        {
            // Tu dodaj svojo implementacijo.
            // Ta primer izbere nakljucno veljavno potezo.
            List<Premik> moznosti = new List<Premik>();
            // - Vsekakor se lahko obracamo na mestu.
            moznosti.Add(Premik.Levo);
            moznosti.Add(Premik.Desno);
            moznosti.Add(Premik.Obrni); 
            // - Ostali premiki so odvisni od tega, kaj je na polju pred nami.
            for (int i = 0; i < kajVidim.Length; i++)
            {
                VidenoPolje vp = kajVidim[i];
                if (vp.rowsAhead != 1 || vp.column != 0) continue;
                // - Ce je polje pred nami prosto, lahko stopimo nanj.
                if (vp.tip == TipPolja.Izhod || vp.tip == TipPolja.Prosto)
                {
                    moznosti.Add(Premik.Naprej);
                    // Ce nosimo breme, ga lahko tudi odlozimo.
                    if (nosimBreme && vp.tip == TipPolja.Prosto) moznosti.Add(Premik.Spusti);
                }
                // - Ce polje pred nami ni prosto, lahko poskusimo kocko na njem pobrati.
                else if (vp.tip == TipPolja.KockaAliZid && !nosimBreme)
                {
                    moznosti.Add(Premik.Poberi);
                    moznosti.Add(Premik.Poberi);
                    moznosti.Add(Premik.Poberi);
                }
            }
            return moznosti[rnd.Next(moznosti.Count)];
        }

        public void KonecIgre(ZakajKonec razlog, string opis)
        {
            // Tu dodaj svojo implementacijo.
            Console.WriteLine("Konec igre, razlog = " + (razlog == ZakajKonec.Zmaga ? "ZMAGA" : razlog == ZakajKonec.Napaka ? "NAPAKA" : "DRUGO") + ": " + opis);
        }
    }
}
